var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __name = (target, value) => __defProp(target, "name", { value, configurable: true });
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var auth_exports = {};
__export(auth_exports, {
  BaseAuth: () => BaseAuth
});
module.exports = __toCommonJS(auth_exports);
var import_auth = require("../auth");
const _BaseAuth = class _BaseAuth extends import_auth.Auth {
  userCollection;
  constructor(config) {
    const { userCollection } = config;
    super(config);
    this.userCollection = userCollection;
  }
  get userRepository() {
    return this.userCollection.repository;
  }
  get jwt() {
    return this.ctx.app.authManager.jwt;
  }
  set user(user) {
    this.ctx.state.currentUser = user;
  }
  get user() {
    return this.ctx.state.currentUser;
  }
  getCacheKey(userId) {
    return `auth:${userId}`;
  }
  validateUsername(username) {
    return /^[^@.<>"'/]{2,16}$/.test(username);
  }
  async check() {
    const token = this.ctx.getBearerToken();
    if (!token) {
      return null;
    }
    try {
      const { userId, roleName } = await this.jwt.decode(token);
      if (roleName) {
        this.ctx.headers["x-role"] = roleName;
      }
      const cache = this.ctx.cache;
      return await cache.wrap(
        this.getCacheKey(userId),
        () => this.userRepository.findOne({
          filter: {
            id: userId
          },
          raw: true
        })
      );
    } catch (err) {
      this.ctx.logger.error(err, { method: "check" });
      return null;
    }
  }
  async validate() {
    return null;
  }
  async signIn() {
    let user;
    try {
      user = await this.validate();
    } catch (err) {
      this.ctx.throw(401, err.message);
    }
    if (!user) {
      this.ctx.throw(401, "Unauthorized");
    }
    const token = this.jwt.sign({
      userId: user.id
    });
    return {
      user,
      token
    };
  }
  async signOut() {
    const token = this.ctx.getBearerToken();
    if (!token) {
      return;
    }
    const { userId } = await this.jwt.decode(token);
    await this.ctx.app.emitAsync("beforeSignOut", { userId });
    await this.ctx.cache.del(this.getCacheKey(userId));
    return await this.jwt.block(token);
  }
};
__name(_BaseAuth, "BaseAuth");
let BaseAuth = _BaseAuth;
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  BaseAuth
});
